;
; ----------------------------------------------------------
;
;	obNCgCo[^PWMvO
;
;	PUSH-SW ɂUP/DOWN 8iKPx
;	@2Port4ނ̃[hʐAX[vt
;
;	Copyright(c) 2008 By Yutaka Kyotani
;
; ----------------------------------------------------------
;
	LIST		P=PIC12F629
	INCLUDE		"P12F629.INC"
	INCLUDE		"YKMACRO.MAC"

	__CONFIG	_CP_OFF & _CPD_OFF & _BODEN_ON & _MCLRE_OFF & _PWRTE_ON & _WDT_ON & _INTRC_OSC_NOCLKOUT

	RADIX		dec

;
;	CLK= CRU 4MHz	 1߂1uS
;	PWMFreq= 91Hz		 11000tcy (44tcy * 250)

PWM_MINVALUE	EQU	.30		; PWMŏJEgl
PWM_MAXVALUE	EQU	.250		; PWMőJEgl
KEY_MAXVALUE	EQU	.7		; ŏPx 0  7 őPx

CSTART_COUNT	EQU	.180		; X^[g̍őPxێJEg=180(2b)
EEP_SAVETIME	EQU	.90		; KeyȂȂĂSAVE܂ł̃^C}[

BRIGHTDN_SW	EQU	.0		; GPIO0= uCglXSW (0:PUSH)
BRIGHTUP_SW	EQU	.1		; GPIO1= uCglXSW (0:PUSH)
MODE_PORT0	EQU	.2		; GPIO2= [h0
MODE_PORT1	EQU	.3		; GPIO3= [h1
BKLT_ON_OFF	EQU	.4		; GPIO4= obNCgON/OFF (1:ON)
PWM_OUT		EQU	.5		; GPIO5= PWMo (1:ON)

GET_OSCCAL	EQU	03FFH		; IV[^[Lu[Vl𓾂

WORK1		EQU	020H		; [N擪

INTSAVE		EQU	WORK1		; 荞݃[`ł̃ReLXgۑp
WSAVE		EQU	INTSAVE+00H	; 荞 Wregۑp
SSAVE		EQU	INTSAVE+01H	; 荞 STATUSۑp
FSAVE		EQU	INTSAVE+02H	; 荞 FSRۑp

WORK2		EQU	WORK1+03H
PWMVAL1		EQU	WORK2+00H	; PWM ONJEgl
PWMVAL2		EQU	WORK2+01H	; PWM OFFJEgl
CSTART		EQU	WORK2+02H	; X^[g̍őPxێJEg
OLDKEY1		EQU	WORK2+03H	; DN_KEY PUSHԕۑp
OLDKEY2		EQU	WORK2+04H	; UP_KEY PUSHԕۑp
EEPCOUNT	EQU	WORK2+05H	; EEPROMۑ܂ł̎^C}[ 0:OFF
EEPSDATA	EQU	WORK2+06H	; EEPROMɕۑf[^
EEPSMODE	EQU	WORK2+07H	; EEPROMɕۑׂf[^̃[h
MODECHGF	EQU	WORK2+08H	; [hωƂ 0:ʏ, 1:ω
OUTMODE		EQU	WORK2+09H	; ϊl̃[h
OUTVAL		EQU	WORK2+0AH	; ϊli[p 4Mode/4Bytes

WORK3		EQU	WORK2+0EH
TEMPWORK	EQU	WORK3+00H	; e|[N

	ORG	00H
	GOTO	START

	ORG	04H
	GOTO	INTERRUPT

;
; ----------------------------------------------------------
;
;	C[`
;
; ----------------------------------------------------------
;
START:
	BANK0				; BANK 0 I
	CLRF	GPIO			; GPIO NA
	MOVLW	B'00000111'		; Rp[^͑SDigital[h
	MOVWF	CMCON
	BANK1				; BANK 1 I
	CALL	GET_OSCCAL
	MOVWF	OSCCAL
	MOVLW	B'00011111'		; GPIO  --543210 -> --oIIIII
	MOVWF	TRISIO
;;;	MOVLW	B'01100000'		; ADCS210 ANS3 ANS2 ANS1 ANS0	-> For PIC12F675
;;;	MOVWF	ANSEL			; 110 /64 0:D  0:D  0:D  0:D	-> For PIC12F675
	MOVLW	B'00001100'		; GPPU  INTEDG TOCS  TOSE PSA PS210
	MOVWF	OPTION_REG		; 0:ON  0:   0:INT 0: 1:W 100:1/16
	MOVLW	B'00010011'		; WPU5  WPU4 xxx3  WPU2  WPU1 WPU0
	MOVWF	WPU			; 0:OFF 1:ON 0:OFF 0:OFF 1:ON 1:ON
	CLRF	INTCON			; |[g`FW荞݃tONA
	CLRF	IOC			; 荞݂ɂX[v̖ڊoߑΉ
	BANK0				; BANK 0 I

	MOVLW	KEY_MAXVALUE		; KEY̌(MAXl)ZbgĂ
	MOVWF	OUTVAL
	MOVLW	CSTART_COUNT		; őPxێJEgZbg
	MOVWF	CSTART
	CLRF	EEPCOUNT		; EEPROMۑ^C}[NA
	CLRF	OUTMODE			; [hNAĂ

	MOVF	OUTMODE,W		; Mode=0A[N̐擪Zbg
	ADDLW	OUTVAL
	MOVWF	FSR

	CLRWDT				; ԌNZbg
;
;	N̓ʏ(őPx)[v
;
LOOP_011:
	CALL	SLEEPCHK		; obNCgON/OFF(SLEEP) M̔
	CALL	PUT_PWM			; Nサ΂炭͍őPxo͂
	CLRWDT				; ԌNZbg
	DJNZ	CSTART, LOOP_011
	BSF	OUTMODE,7		; _~[̃[hZbgĂ
	CALL	MODECHK			; [h(Port)`FbNs
	CALL	EEP_READ		; EEPROMݒlǂݏo
;
;	C[v
;
LOOP_012:
	CALL	SLEEPCHK		; obNCgON/OFF(SLEEP) M̔
	CALL	MODECHK			; [h(Port)`FbNs
	CALL	EEP_READ		; EEPROMݒlǂݏo
	CALL	GET_KEYVALUE		; őPxێԏI͐ݒlo
	CALL	EEP_SAVECHK		; ^C}[`FbNEEPROMɐݒlۑ
	CALL	PUT_PWM			; PWMs
	CLRWDT				; ԌNZbg

	GOTO	LOOP_012

;
;	Key͏sl𓾂
;
GET_KEYVALUE:
	MOVF	MODECHGF,W		; [hωォH
	RETNZ				; ωȂKey͂xŖ߂

	RRF	GPIO,W			; BRIGHTDN_SW = B0C
	MOVWF	TEMPWORK
	RRF	OLDKEY1,F		; B7: ŐVDN_KEY  ÂDN_KEY :B0
	RRF	TEMPWORK,W		; BRIGHTUP_SW = B1C
	RRF	OLDKEY2,F		; B7: ŐVDN_KEY  ÂDN_KEY :B0

	MOVLW	B'11111000'		; ߋ4Clk܂ŉĂȂƂmF
	ANDWF	OLDKEY1,W
	XORLW	B'01111000'		; ʂ0Ȃ牟ĂƂ݂Ȃ
	JNZ	GETKEY_011		; ĂȂ̂Ŏ̏

	DECF	INDF,W
	MOVWF	INDF
	ADDLW	.0 - KEY_MAXVALUE - .1	; ől𒴂ĂȂ
	SKIPNC				; NC: ϊl͔͈͓
	CLRF	INDF			; ͈͊Ȍꍇ͌ʂNA

	GOTO	GETKEY_012

GETKEY_011:
	MOVLW	B'11111000'		; ߋ4Clk܂ŉĂȂƂmF
	ANDWF	OLDKEY2,W
	XORLW	B'01111000'		; ʂ0Ȃ牟ĂƂ݂Ȃ
	RETNZ				; ĂȂ̂Ŗ߂

	INCF	INDF,W
	MOVWF	INDF
	ADDLW	.0 - KEY_MAXVALUE - .1	; ől𒴂ĂȂ
	JNC	GETKEY_012		; NC: ϊl͔͈͓
	MOVLW	KEY_MAXVALUE		; ͈͊Ȍꍇ͌ʂől
	MOVWF	INDF
GETKEY_012:
	MOVLW	EEP_SAVETIME		; EEPROMɕۑ܂ł̎^C}[n
	MOVWF	EEPCOUNT
	MOVF	INDF,W			; EEPROMɕۑf[^
	MOVWF	EEPSDATA
	MOVF	OUTMODE,W		; EEPROMɕۑf[^̃[h
	MOVWF	EEPSMODE

	RETURN

;
;	[h(Port)`FbNs
;
MODECHK:
	CLRF	MODECHGF		; [hωtONA
	RRF	GPIO,W			; GPIO[2:3]->Mode
	MOVWF	TEMPWORK		; PortǂŐ`
	RRF	TEMPWORK,W
	ANDLW	B'00000011'
	MOVWF	TEMPWORK
	SUBWF	OUTMODE,W		; Z:ωȂANZ:ω
	RETZ				; [h͕ωĂȂ̂Ŗ߂

	BSF	MODECHGF,0		; [hωtO ON
	MOVF	TEMPWORK,W
	MOVWF	OUTMODE			; ϊl̃[h𔽉f
	ADDLW	OUTVAL
	MOVWF	FSR			; f[^̕ۑݒ

	RETURN
;
;	ݒlPWMo͂
;
PUT_PWM:
	MOVF	INDF,W			; PWM ONJEgle[u瓾
	CALL	PUTPWM_030
	MOVWF	PWMVAL1
					; PWM OFFJEgľvZ
	SUBLW	PWM_MAXVALUE + .1	; PWM_MAXVALUE + 1 - ONJEg
	MOVWF	PWMVAL2			; -1̂ +1Ă

	BSF	GPIO, PWM_OUT		; GP5= PWM OUT ON
PUTPWM_010:
	CALL	PWM_DELAY
	DJNZ	PWMVAL1, PUTPWM_010	; PWM ONJEgl܂Ŏԑ҂

	DJNZ	PWMVAL2, PUTPWM_020	; PWM OFFJEg 0
	RETURN				; 0ȂOFFȂ ON̂܂ܖ߂

PUTPWM_020:
	CLRF	GPIO			; PWM OUT OFF
PUTPWM_021:
	CALL	PWM_DELAY
	DJNZ	PWMVAL2, PUTPWM_021	; PWM OFFJEgl܂Ŏԑ҂
	BSF	GPIO, PWM_OUT		; GP5= PWM OUT ON

	RETURN

;
;	PWMϊpe[u
;
PUTPWM_030:
	ADDWF	PCL,F

	RETLW	PWM_MINVALUE		; 0: ŏPx
	RETLW	PWM_MINVALUE + ((PWM_MAXVALUE-PWM_MINVALUE) / 20) * 2
	RETLW	PWM_MINVALUE + ((PWM_MAXVALUE-PWM_MINVALUE) / 20) * 4
	RETLW	PWM_MINVALUE + ((PWM_MAXVALUE-PWM_MINVALUE) / 20) * 6
	RETLW	PWM_MINVALUE + ((PWM_MAXVALUE-PWM_MINVALUE) / 20) * 9
	RETLW	PWM_MINVALUE + ((PWM_MAXVALUE-PWM_MINVALUE) / 20) * 12
	RETLW	PWM_MINVALUE + ((PWM_MAXVALUE-PWM_MINVALUE) / 20) * 16
	RETLW	PWM_MAXVALUE		; 7: őPx

;
;	PWMp 41tcyDELAY
;
PWM_DELAY:
	GOTO	$+1
	GOTO	$+1
	GOTO	$+1
	GOTO	$+1
	GOTO	$+1

	GOTO	$+1
	GOTO	$+1
	GOTO	$+1
	GOTO	$+1
	GOTO	$+1

	GOTO	$+1
	GOTO	$+1
	GOTO	$+1
	GOTO	$+1
	GOTO	$+1

	GOTO	$+1
	GOTO	$+1
	GOTO	$+1
	NOP
	RETURN

;
;	obNCgON/OFF(SLEEP) M̔
;
SLEEPCHK:
	BTFSC	GPIO, BKLT_ON_OFF
	RETURN				; |[gONȂ炻̂܂ܖ߂

	CLRF	GPIO			; |[gOFFȂ PWMo͂OFF
	CALL	PWM_DELAY

	MOVF	EEPCOUNT,W		; EEPROM݃JE^nĂ邩
	JZ	SLEEPCHK_001		; nĂȂȂ炻̂܂SLEEP

	MOVLW	.1			; EEPROMݏȂ瑦ݎs
	MOVWF	EEPCOUNT
	CALL	EEP_SAVECHK		; EEPROMɐݒlۑ
	CALL	EEP_SAVEWAIT		;    //   ݊܂ő҂

SLEEPCHK_001:
	CLRF	GPIO			; ēxGPIONA
	BANK1				; BANK 1 I
	CLRF	INTCON			; |[g`FW荞݃tONA
	CLRF	IOC
	BANK0				; BANK 0 I
	BTFSC	GPIO, BKLT_ON_OFF
	GOTO	START			; Ń|[gONȂR[hX^[g

	BANK1				; BANK 1 I
	BSF	INTCON, GPIE		; |[g`FW荞݋
	BSF	IOC, BKLT_ON_OFF
	BANK0				; BANK 0 IE
	SLEEP				; GIEONɂĂȂ̂Ŏ̖߂s
	GOTO	START			; SLEEP̋N̓R[hX^[g

;
;	^C}[`FbNEEPROMɐݒlۑ
;
EEP_SAVECHK:
	BTFSC	PIR1,EEIF		; EEPROM݊荞݃tOON
	GOTO	EEPSC_010		; ONȂۑǏns

EEPSC_001:
	MOVF	EEPCOUNT,W		; ^C}[ 0
	RETZ				; 0Ȃ牽߂

	MOVF	MODECHGF,W		; [hωォH
	JNZ	EEPSC_002		; ωȂ狭ۑXe[g

	DECFSZ	EEPCOUNT,F		; ^C}[fNg
	RETURN				; 0ɂȂȂ΂̂܂ܖ߂
					; ^CAEg܂Key͂Ȃ
EEPSC_002:
;;;	BCF	INTCON,GIE		; {͂Ŋ荞݂֎~
	MOVF	EEPSMODE,W		; EEPROMɕۑׂf[^̃[h𓾂
	BANK1				; BANK 1 I
	MOVWF	EEADR			; ϊlۑ  0`3Ԓn
	MOVF	EEPSDATA,W
	MOVWF	EEDATA
	BSF	EECON1,WREN		; Write Enable
	MOVLW	055H			; ܂̂܂Ȃ
	MOVWF	EECON2
	MOVLW	0AAH
	MOVWF	EECON2
	BSF	EECON1,WR		; Write Go!
	BANK0				; BANK 0 I
;;;	BSF	INTCON,GIE		; {͂Ŋ荞݂

	CLRF	EEPCOUNT		; 0łȂꍇ̂ŃNAďI
	RETURN

EEPSC_010:				; EEPROMۑǏn
	BCF	PIR1,EEIF		; EEPROM݊荞݃tONA
	BANK1				; BANK 1 I
	BCF	EECON1,WREN		; Write Enable OFF
	BANK0				; BANK 0 I

	GOTO	EEPSC_001

;
;	EEPROMݒlǂݏo
;
EEP_READ:
	MOVF	MODECHGF,W		; [hωォH
	RETZ				; ωȊOȂ߂

	MOVF	OUTMODE,W		; ݂̃[h𓾂
	ANDLW	B'00000011'
	BANK1				; BANK 1 I
	MOVWF	EEADR			; ǂݏoAhXZbg  0`3Ԓn
	BSF	EECON1,RD		; Read Go!
	MOVF	EEDATA,W		; ݒl𓾂
	BANK0				; BANK 0 I

	MOVWF	INDF			; ϊlƂĊi[
	ADDLW	.0 - KEY_MAXVALUE - .1	; ől𒴂ĂȂ
	SKIPC
	RETURN				; NC: ϊl͔͈͓
					; C: ől𒴂Ă
	MOVLW	KEY_MAXVALUE		; lőlɊۂ߂
	MOVWF	INDF

	RETURN

;
;	EEPROM ۑ܂ő҂
;
EEP_SAVEWAIT:
	BTFSS	PIR1,EEIF		; EEPROM݊荞݃tOON
	GOTO	EEP_SAVEWAIT		; OFFȂONɂȂ܂ŌJԂ

	BCF	PIR1,EEIF		; EEPROM݊荞݃tONA
	BANK1				; BANK 1 I
	BCF	EECON1,WREN		; Write Enable OFF
	BANK0				; BANK 0 I

	RETURN

;
;	荞݃[`
;
;	Ӂ@݂̓_~[ł
;
INTERRUPT:
	MOVWF	WSAVE			; Wregۑ
	SWAPF	STATUS,W		; STATUSۑ
	MOVWF	SSAVE
	MOVF	FSR,W			; FSRۑ
	MOVWF	FSAVE

	BANK0				; BANK 0 I
					; Ɋ荞ݏւ̕Lq
	MOVF	FSAVE,W
	MOVWF	FSR			; FSRA
	SWAPF	SSAVE,W
	MOVWF	STATUS			; STATUSA
	SWAPF	WSAVE,F			; WregA
	SWAPF	WSAVE,W			; Zflagی̂SWAPFgp
	RETFIE

	END
